# rex

`rex` is the king of dependencies. it other words - it lets you use common.js in the browser and the same awesome package resolution as node.js by looking for `js_modules` folders to resolve modules and by looking for local files to resolve paths.

it's available through npm

	npm install rex
	
usage is simple

``` js
var rex = require('rex');

rex.parse('resolve.me.js', callback);
```

## require

`resolve.me.js` can use `require` to load dependencies

``` js
// resolve.me.js contents

var foo = require('foo');
var bar = require('./bar');

console.log(foo.test);
```
## module resolution

module resolution like resolving `foo` in the above example follows the exact same pattern as [resolving modules in node.js](http://nodejs.org/docs/v0.4.10/api/modules.html#loading_from_node_modules_Folders) with the exception that `rex` looks for `js_modules` instead of `node_modules`.

to resolve a file path `rex` simply joins the current working directory with the path and adds `.js` to the end of the path if necessary, exactly the same behavior as in node.js.

## module exports

to export functions or values from a module attach them to `exports` or override `module.exports` to only specify the `exports` itself.

``` js
// js_modules/foo.js contents

exports.test = 'hello world';
```