module.exports = function(parallel) {
	var using = 0;
	var queued = [];

	var free = function() {
		using--;

		while (queued.length && using < parallel) {
			work(queued.shift());
		}
	};

	free.wrap = function(callback) {
		return function(err, value) {
			free();
			callback(err, value);
		};
	};

	var work = function(fn) {
		if (using < parallel) {
			using++;
			fn(free);
			return;
		}
		queued.push(fn);
	};

	return work;
};