var http = require('http');
var cat = require('cat');
var common = require('common');
var rex = require('./index');
var path = require('path');
var parse = require('url').parse;

var onreferer = function(referer, dir, response) {
	common.step([
		function(next) {
			cat(referer, next);
		},
		function(src, next) {
			rex.parseSource(src, {cwd:dir, exclude:'entry'}, next);
		},
		function(src) {
			response.writeHead(200, {'content-type':'text/javascript'});
			response.end(src);		
		}
	], function(err) {
		response.writeHead(200, {'content-type':'text/javascript'});
		response.end('console.log('+JSON.stringify(err.stack)+');');
	})
};

exports.listen = function(dir, port) {
	var server = http.createServer(function(request, response) {
		var url = parse(request.url, true);
		var referer = request.headers.referer || url.query.ref;

		if (!referer) {
			var host = 'http://'+request.headers.host.split(':')[0]+':' + (port || 20000);

			response.writeHead(200, {'content-type':'text/javascript'});
			response.end('document.write("<"+"script src=\''+host+url.pathname+'?ref="+encodeURIComponent(window.location.toString())+"\'><"+"/script>");');			
			return;
		}

		var cwd = url.pathname.substring(1);

		if (cwd && cwd[0] !== '~') {
			cwd = '/' + cwd;
		}

		cwd = cwd.replace(/^~/, process.env.HOME) || dir || (/^file:\/\//i.test(referer) ? path.dirname(referer.replace(/^(file:\/\/)?[^\/]*/g, '')) : '.');

		onreferer(referer, cwd, response);
	});

	server.listen(port || 20000);	
};
